#include "wkup.h"
#include "led.h"
#include "delay.h"
//////////////////////////////////////////////////////////////////////////////////	 
//
// 	   
//////////////////////////////////////////////////////////////////////////////////

void Sys_Standby(void)
{  
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_PWR, ENABLE);	//ʹPWRʱ
    //	RCC->APB2RSTR|=0X01FC;//λIO
    PWR_WakeUpPinCmd(ENABLE);  //ʹܻѹܽŹ
    PWR_EnterSTANDBYMode();	  //STANDBYģʽ 
    
}

//WKUPŵź
//ֵ1:
//      0:Ĵ	
u8 Check_WKUP(void) 
{
    u8 t=0;	//¼µʱ
    LED1_ON();
    LED2_ON();
    LED3_ON();
    LED4_ON();
    
    while(1)
    {
        if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))
        {
            t++;
            delay_ms(20);      
            if(t>=100)		//³2
            {
                LED1_ON();
                LED2_ON();
                LED3_ON();
                LED4_ON();
                return 1; 	//3s
            }
            
        }
        else 
        { 
            LED1_OFF();
            LED2_OFF();
            LED3_OFF();
            LED4_OFF();
            return 0; //²3
        }
        
    }
    
}  


/********************************************************************************************************
**Ϣ EXTI0_IRQHandler(void)                         
** ⲿж0жϱ־λ
** 
** 
********************************************************************************************************/
void EXTI0_1_IRQHandler(void)
{ 		    		    				     		    
    EXTI_ClearITPendingBit(EXTI_Line0); // LINE10ϵжϱ־λ		  
} 

/********************************************************************************************************
**Ϣ WKUP_Init(void)                         
** ⲿжϻѴʼ
** 
** 
********************************************************************************************************/
void WKUP_Init(void)
{	
    GPIO_InitTypeDef GPIO_InitStructure;  		  
    NVIC_InitTypeDef NVIC_InitStructure;
    EXTI_InitTypeDef EXTI_InitStructure;
    
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);//ʹGPIOA͸ùʱ
    
    GPIO_InitStructure.GPIO_Pin =GPIO_Pin_0;	 //PA.0
    GPIO_InitStructure.GPIO_Mode =GPIO_Mode_IPD;//
    GPIO_Init(GPIOA, &GPIO_InitStructure);	//ʼIO
    //ʹⲿжϷʽ
    SYSCFG_EXTILineConfig(GPIO_PortSourceGPIOA, GPIO_PinSource0);	//ж0GPIOA.0
    
    EXTI_InitStructure.EXTI_Line = EXTI_Line0;	//ðеⲿ·
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;			//ⲿжģʽ:EXTI·Ϊж
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising;  //ش
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    EXTI_Init(&EXTI_InitStructure);	// ʼⲿж
    
    NVIC_InitStructure.NVIC_IRQChannel = EXTI0_1_IRQn; //ʹܰڵⲿжͨ
    NVIC_InitStructure.NVIC_IRQChannelPriority = 2; //ȼ2
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //ʹⲿжͨ
    NVIC_Init(&NVIC_InitStructure); //NVIC_InitStructָĲʼNVICĴ
    
    if(Check_WKUP()==0) Sys_Standby();    //ǿ,ģʽ  
}
















