#include "sys.h"

/********************************************************************************************************
**Ϣ System_Clock_Init(u8 PLL)                     
** ⲿʱӱƵΪϵͳʱ
** PLLƵ
** 
********************************************************************************************************/
void System_Clock_Init(u8 PLL)
{
    unsigned char temp=0;   
    RCC->CR|=RCC_CR_HSEON;  //ⲿʱʹHSEON
    while(!(RCC->CR&RCC_CR_HSERDY));//ȴⲿʱӾ
    RCC->CFGR=RCC_CFGR_PPRE1_2; //APB1=DIV2;APB2=DIV1;AHB=DIV1;
    
    RCC->CFGR|=RCC_CFGR_PLLSRC;	  //PLLSRC ON 
    RCC->CR &=~(RCC_CR_PLLON);		//PLL//	RCC->CR &=~(7<<20);		//PLL
    
    RCC->CR &=~(0x1f<<26);	
    RCC->CR|=(PLL - 1) << 26;   //PLLֵ 2~16
    
    FLASH->ACR|=FLASH_ACR_LATENCY_1|FLASH_ACR_PRFTBE|FLASH_ACR_PRFTBS;	  //FLASH 2ʱ
    
    RCC->CR|=RCC_CR_PLLON;  //PLLON
    while(!(RCC->CR&RCC_CR_PLLRDY));//ȴPLL
    RCC->CFGR|=RCC_CFGR_SW_PLL;//PLLΪϵͳʱ	 
    while(temp!=0x02)     //ȴPLLΪϵͳʱóɹ
    {    
        temp=RCC->CFGR>>2;
        temp&=0x03;
    }    
}	



