/**
******************************************************************************
* @file    wwdg.c  
* @brief   ôڿŹ
*          
******************************************************************************
*/
/* Includes ------------------------------------------------------------------*/
#include "HAL_device.h"
#include "HAL_conf.h"
/********************************************************************************************************
**Ϣ void WWDG_IRQHandler (void)                   
** ڿŹжϺ
** 
** 
**    ע ݼ0x40ʱж
С0x7f0x40,ӽ0x40ܻƵж           
********************************************************************************************************/
void WWDG_IRQHandler (void)
{	
    if(WWDG_GetFlagStatus())
    {
        WWDG_ClearFlag();
        WWDG_SetCounter(0x66);                                                                               
    }
}

/********************************************************************************************************
**Ϣ Wwdg_reset_test()                     
** ʹôڿŹ
** unsigned char ucTcn Źݼֵ
unsigned char ucWcntֵ
** 
**    ע ϵͳʱŹΪʧ״̬,Źʧֶܺر,λŹʧ 
WWDG_SetCounter(0x7e);ι
WWDG_Enable(0x7e);Źʹֵܲ
ڿŹλʱΪ΢뵽뼶,öʱȴλ
WWDG counter clock = (PCLK1/4096)/x 
********************************************************************************************************/
void Wwdg_reset_ON(unsigned char ucTcnt,unsigned char ucWcnt)
{
    /*ʧܴڿŹʱ*/
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);
    
    /*WWDG_Prescaler_x,xΪ1,2,4,8,WWDG counter clock = (PCLK1/4096)/x */
    WWDG_SetPrescaler(WWDG_Prescaler_8);
    WWDG_SetWindowValue(ucWcnt);
    
    /*ΪŹԼֵ,Ϊ7λֵΪ0x40~0x7f֮*/
    WWDG_Enable(ucTcnt);
}

/********************************************************************************************************
**Ϣ void Wwdg_ExterslReloadReset_test(void)                   
** λ
** 
** 
**    ע Կ˳úλ,ҪһʱĸλɿǴ˺,
ϿŹжʹñϵͳλ,жʱ,ѡ
κ.
********************************************************************************************************/
void Wwdg_ExterslReloadReset_ON(void)
{
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);                                                   //
    WWDG_SetPrescaler(WWDG_Prescaler_8);                                                                   //
    /*˴ָСֵ,ҷΧ,С0x80*/
    WWDG_SetWindowValue(0x70);	                                                                           //
    /*˴ֵָ,ҷΧ,С0x7f0x40*/
    WWDG_Enable(0x75);
}

/********************************************************************************************************
**Ϣ Wwdg_irq_test()                      
** ڿŹж
** 
** 
********************************************************************************************************/
void Wwdg_irq_ON(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    
    NVIC_InitStructure.NVIC_IRQChannel = WWDG_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_WWDG, ENABLE);
    WWDG_SetWindowValue(0x70);
    WWDG_EnableIT();
    /*˴Ϊ,ֵСڴֵ,λ*/
    WWDG_Enable(0x66);		
}

