#include "HAL_rcc.h"
#include "HAL_iwdg.h"
#include "iwdg.h" 
/********************************************************************************************************
**Ϣ PVU_CheckStatus(void)                       
** ŹԤƵλ״̬
** 
** 
********************************************************************************************************/
void PVU_CheckStatus(void)
{
    while(1)
    {
        /*ԤƵλ״̬,ΪRESETſɸıԤƵֵ*/
        if(IWDG_GetFlagStatus(IWDG_FLAG_PVU)==RESET)                                                       
        {
            break;
        }
    }
}
/********************************************************************************************************
**Ϣ RVU_CheckStatus(void)                  
** Źر־
** 
** 
********************************************************************************************************/
void RVU_CheckStatus(void)
{
    while(1)
    {
        /*ر־״̬*/
        if(IWDG_GetFlagStatus(IWDG_FLAG_RVU)==RESET)  
        {
            break;
        }
    }
}
/********************************************************************************************************
**Ϣ Write_Iwdg_PR(void)             
** Ź
** IWDG_Prescaler ѡIWDG_Prescaler_X, XΪ4,8,16,32,64,128,256,ӦƵֵXȡֵͬ
Reload<=0xfff,Ϊֵ
** 
**    ע λʱLSI 40KHzΪο
Tiwdg=(X/LSI)*Reload
********************************************************************************************************/
void Write_Iwdg_ON(unsigned short int IWDG_Prescaler,unsigned short int Reload)
{
    /*ڲʱ,ȴʱӾ*/
    RCC_LSICmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_LSIRDY)==RESET);
    
    /*ʱԤƵ*/	
    PVU_CheckStatus();
    IWDG_WriteAccessCmd(0x5555);
    IWDG_SetPrescaler(IWDG_Prescaler);
    
    /*ؼĴֵ*/	
    RVU_CheckStatus();
    IWDG_WriteAccessCmd(0x5555);
    IWDG_SetReload(Reload&0xfff);	
    
    /*װزʹܼ*/	
    IWDG_ReloadCounter();
    IWDG_Enable();
}

/********************************************************************************************************
**Ϣ void Write_Iwdg_RL(void)           
** ι
** 
** 
********************************************************************************************************/
void Write_Iwdg_RL(void)
{
    IWDG_ReloadCounter();
}

