#include "delay.h"

#define USE_SYSTICK_DELAY 1	 //1Ϊʹsystickʱ0Ϊͨʱ

/*ʹsystickΪʱһҪȳʼsystickȵúdelay_init(u8 pclk2)*/

#if USE_SYSTICK_DELAY
static __IO uint32_t TimingDelay;

extern u32 SystemCoreClock;
/********************************************************************************************************
**Ϣ delay_init()                 
** systickʱʼ
** 
** 
********************************************************************************************************/
void delay_init()
{
    if (SysTick_Config(SystemCoreClock / 1000))
    { 
        /* Capture error */ 
        while (1);
    }
    /* Configure the SysTick handler priority */
    NVIC_SetPriority(SysTick_IRQn, 0x0);//SysTickжȼ
}

/********************************************************************************************************
**Ϣ TimingDelay_Decrement(void)               
** 1msٶȵݼ
** pclk2ϵͳʱΪ8MHzӦ8
** 
********************************************************************************************************/
void TimingDelay_Decrement(void)
{
    if (TimingDelay != 0x00)
    { 
        TimingDelay--;
    }
}

/********************************************************************************************************
**Ϣ SysTick_Handler(void)                    
** жϺSystickеݼ
** 
** 
********************************************************************************************************/
void SysTick_Handler(void)
{
    TimingDelay_Decrement();
}

/********************************************************************************************************
**Ϣ delay_ms(__IO uint32_t nTime)                     
** Ӧõʱʹsystick
** nTimeʱ
** 
********************************************************************************************************/
void delay_ms(__IO uint32_t nTime)
{ 
    TimingDelay = nTime;
    
    while(TimingDelay != 0);
}
#else

/********************************************************************************************************
**Ϣ delay_us(__IO uint32_t nTime)                 
** Ӧõʱ
** nTimeʱ
** 
********************************************************************************************************/
void delay_us(__IO uint32_t nTime)
{		
    u16 i=0;   
    while(nTime--)   
    {   
        i=10;  //Լ      
        while(i--);       
    }					 
}
/********************************************************************************************************
**Ϣ delay_ms(__IO uint32_t nTime)                     
** Ӧõʱ
** nTimeʱ
** 
********************************************************************************************************/
void delay_ms(__IO uint32_t nTime)
{	 		  	  
    u16 i=0;   
    while(nTime--)   
    {      
        i=750;  //Լ    
        while(i--);        
    }	  	    
} 
#endif








































