/**
******************************************************************************
* @file    wwdg_test.c  
* @brief   öʱ3,ʵ·ɵ10KHz PWM
*          PA6,PA7ɹ۲
******************************************************************************
*/

/* Includes ------------------------------------------------------------------*/
#include "pwm.h" 

//PWMʼ
//arrԶװֵ
//pscʱԤƵ
void TIM3_PWM_Init(u16 arr,u16 psc)
{  
    GPIO_InitTypeDef GPIO_InitStructure;
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    TIM_OCInitTypeDef  TIM_OCInitStructure;
    
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
    
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOB, ENABLE);  //GPIOBʱ
    
    //SYSCFG->CFGR|=0x1<<11;
    GPIOB->AFRL=0x10000;
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4; //TIM3_CH1
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    
    
    TIM_TimeBaseStructure.TIM_Period = arr; //һ¼װԶװؼĴڵֵ	 80K
    TIM_TimeBaseStructure.TIM_Prescaler =psc; //ΪTIMxʱƵʳԤƵֵ  Ƶ
    TIM_TimeBaseStructure.TIM_ClockDivision = 0; //ʱӷָ:TDTS = Tck_tim
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //TIM_TimeBaseInitStructָĲʼTIMxʱλ
    
    TIM_OCStructInit(&TIM_OCInitStructure);
    TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM2; //ѡʱģʽ:TIMȵģʽ2
    TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable; //Ƚʹ
    TIM_OCInitStructure.TIM_Pulse = 0; //ôװ벶ȽϼĴֵ
    TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High; //:TIMȽϼԸ
    TIM_OC1Init(TIM3, &TIM_OCInitStructure);  //TIM_OCInitStructָĲʼTIMx
    
    
    TIM_OC1PreloadConfig(TIM3, TIM_OCPreload_Enable);  //CH1Ԥװʹ	 
    
    TIM_ARRPreloadConfig(TIM3, ENABLE); //ʹTIMxARRϵԤװؼĴ
    
    TIM_Cmd(TIM3, ENABLE);  //ʹTIM1
    
    
}



