#include "uart_nvic.h"


//1жϷ
u8 UART_RX_BUF[UART_REC_LEN];     //ջ,UART_REC_LENֽ.
//״̬
//bit15	ɱ־
//bit14	յ0x0d
//bit13~0	յЧֽĿ
u16 UART_RX_STA=0;       //״̬	  

void uart_nvic_init(u32 bound){
    //GPIO˿
    GPIO_InitTypeDef GPIO_InitStructure;
    UART_InitTypeDef UART_InitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;
    
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_UART1, ENABLE);	//ʹUART1
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);  //GPIOAʱ
    
    //UART1 NVIC 
    NVIC_InitStructure.NVIC_IRQChannel = UART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPriority = 3;		//ȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;			//IRQͨʹ
    NVIC_Init(&NVIC_InitStructure);	//ָĲʼVICĴ
    
    //UART ʼ
    GPIO_PinAFConfig(GPIOA,GPIO_PinSource9,GPIO_AF_1);
    GPIO_PinAFConfig(GPIOA,GPIO_PinSource10,GPIO_AF_1);
    
    UART_InitStructure.UART_BaudRate = bound;//ڲ
    UART_InitStructure.UART_WordLength = UART_WordLength_8b;//ֳΪ8λݸʽ
    UART_InitStructure.UART_StopBits = UART_StopBits_1;//һֹͣλ
    UART_InitStructure.UART_Parity = UART_Parity_No;//żУλ
    UART_InitStructure.UART_HardwareFlowControl = UART_HardwareFlowControl_None;//Ӳ
    UART_InitStructure.UART_Mode = UART_Mode_Rx | UART_Mode_Tx;	//շģʽ
    
    UART_Init(UART1, &UART_InitStructure); //ʼ1
    UART_ITConfig(UART1, UART_IT_RXIEN, ENABLE);//ڽж
    UART_Cmd(UART1, ENABLE);                    //ʹܴ1 
    
    //UART1_TX   GPIOA.9
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9; //PA.9
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;	//
    GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼGPIOA.9
    
    //UART1_RX	  GPIOA.10ʼ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;//PA10
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;//
    GPIO_Init(GPIOA, &GPIO_InitStructure);//ʼGPIOA.10  
    
}

void UART1_IRQHandler(void)                	//1жϷ
{
    u8 Res;
    if(UART_GetITStatus(UART1, UART_IT_RXIEN)  != RESET)  //ж(յݱ0x0d 0x0aβ)
    {
        UART_ClearITPendingBit(UART1,UART_IT_RXIEN);
        Res =UART_ReceiveData(UART1);	//ȡյ
        if((Res==0x0d)&&((UART_RX_STA&0X3FFF)>0))
        {
            UART_RX_STA|=0x4000;
            UART_RX_BUF[UART_RX_STA&0X3FFF]=Res ;
            UART_RX_STA++;
        }
        else if((UART_RX_STA&0x4000)&&((UART_RX_STA&0X3FFF)>0))//յ0x0d
        {
            if(Res==0x0a)
            {
                UART_RX_STA|=0x8000;				
            }
            UART_RX_BUF[UART_RX_STA&0X3FFF]=Res ;
            UART_RX_STA++;
        }
        else{
            UART_RX_BUF[UART_RX_STA&0X3FFF]=Res ;
            UART_RX_STA++;
            UART_RX_STA=UART_RX_STA&0X3FFF;
            if((UART_RX_STA)>(UART_REC_LEN-1))
                UART_RX_STA=0;//ݴ,¿ʼ	
        }
    } 
} 


