#include "adc.h"

/********************************************************************************************************
**Ϣ void ADC1_SingleChannel(uint8_t ADC_Channel_x)      
** ADC1תģʽ
** ADC_Channel_x , xΪ0~8
** 
**    ע 
********************************************************************************************************/
void ADC1_SingleChannel(void)
{
    RCC->AHBENR |=1<<17;//ʹGPIOAʱ
    RCC->APB2ENR |=RCC_APB2ENR_ADC1EN;//ʹADC1ʱ
    GPIOA->CRL&=0XFFFFFF0F;//PA1 anolog
    
    RCC->APB2RSTR|=RCC_APB2RSTR_ADC1RST;   //ADC1λ
    RCC->APB2RSTR&=~(RCC_APB2RSTR_ADC1RST);//λ	   
    
    /*ADCóɵתģʽ*/
    ADC1->ADCFG |= ADCFG_ADCPRE_8|ADCFG_ADCPRE_10;//8Ƶ
    ADC1->ADCR &= ~(ADCR_ADMD_PERIOD|ADCR_ADMD_CONTINUE|ADCR_ALIGN_LEFT);//ηģʽ,Ҷ
    ADC1->ADCR |=ADCR_ADMD_PERIOD;
    ADC1->ADCHS =ADCHS_CHEN1;//ʹͨ1
    
    ADC1->ADCFG |= ADCFG_ADEN;//ADC1ʹ
    ADC1->ADCR |= ADCR_ADST;//ʼת
}
/********************************************************************************************************
**Ϣ ADC1_SingleChannel_Get()       
** ȡADC1ת
** ADC_Channel_x , xΪ0~8
*puiADData ,ADC1ʵת
** ucStatus ,0 ʾݻȡʧ,1 ʾɹ
********************************************************************************************************/
u16 ADC1_SingleChannel_Get(void)
{ 
    u16 puiADData;
    /*ADCRĴADSTλʹܣת*/
    ADC1->ADCR |=0x00000100;
    while(((ADC1->ADSTA )&0x01)==0);
    
    ADC1->ADSTA |= 0x01;
    puiADData=ADC1->ADDATA&0xfff;
    return puiADData;
}

