#include "uart.h"
#include "sys.h"
#ifdef __GNUC__

#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)

#endif 

#ifdef USE_IAR
PUTCHAR_PROTOTYPE
{
    while((UART1->CSR&((uint16_t)0x0001))==0);//ѭ,ֱ   
    UART1->TDR = (ch & (uint16_t)0x00FF);      
    return ch;
}

#else
#pragma import(__use_no_semihosting)             
//׼Ҫֺ֧                 
struct __FILE 
{ 
    int handle; 
    
}; 

FILE __stdout;       
//_sys_exit()Աʹðģʽ    
_sys_exit(int x) 
{ 
    x = x; 
} 
//ضfputc 
int fputc(int ch, FILE *f)
{      
    while((UART1->CSR&((uint16_t)0x0001))==0);//ѭ,ֱ   
    UART1->TDR = (ch & (uint16_t)0x00FF);      
    return ch;
}

#endif 



void uart_initwBaudRate(u32 bound)
{  	 
    
    u32 tempBaud;	
    
    //-------------------------------------------------
    RCC->AHBENR|=1<<17;   //ʹPORTAʱ  
    RCC->APB2ENR|=1<<14;  //ʹܴʱ 
    
    RCC->APB2RSTR|=1<<14;   //λ1
    RCC->APB2RSTR&=~(1<<14);//ֹͣλ	 
    
    GPIOA->AFRH&=0x00f;
    GPIOA->AFRH|=0x110;
    
    //-------------------------------------------------	
    // 
    /* Determine the uart_baud*/
    tempBaud = (SystemCoreClock / 16) /(bound);
    UART1->FRA=(SystemCoreClock / 16) %(bound);
    /* Write to UART BRR */
    UART1->BRR = tempBaud;
    UART1->CCR|=0X30;  //1λֹͣ,Уλ.
    //-------------------------------------------------	
    //ʹܽж 
    UART1->GCR = 0X19;			//շʹ	UART1->CCR|=1<<5;    //ջǿжʹ	
    UART1->IER = 0X2;			//жʹ
    /*
    23.5.5 UART жʹܼĴ(UART_IER)
    ƫƵַ0x10
    λֵ0x0000
    λ1
    RXIEN:ջжʹλ
    1=жʹ
    0=жϽֹ	
    */
    UART1->ICR = 0X2;			//ж
    /*
    23.5.6 UART жĴ(UART_ICR)
    ƫƵַ0x14
    λֵ0x0000
    λ1
    RXICLR: жλ
    1=ж
    0=жû
    */
    /*
    λ14
    UART1ENUART1ʱʹ
    á1塯0
    0UART1ʱӹرգ
    1UART1ʱӿ	
    */
    GPIOA->CRH&=0XFFFFF00F;//IO״̬
    GPIOA->CRH|=0X000008B0;//IO״̬
    
}

