#include "sys.h"

/********************************************************************************************************
**Ϣ System_Clock_Init(u8 PLL)                     
** ⲿʱӱƵΪϵͳʱ
** PLLƵ
** 
********************************************************************************************************/
void System_Clock_Init(u8 PLL)
{
    unsigned char temp=0;   
    RCC->CR|=RCC_CR_HSEON;  //ⲿʱʹHSEON
    while(!(RCC->CR&RCC_CR_HSERDY));//ȴⲿʱӾ
    RCC->CFGR=RCC_CFGR_PPRE1_2; //APB1=DIV2;APB2=DIV1;AHB=DIV1;
    
    RCC->CFGR|=RCC_CFGR_PLLSRC;	  //PLLSRC ON 
    RCC->CR &=~(RCC_CR_PLLON);		//PLL//	RCC->CR &=~(7<<20);		//PLL
    
    RCC->CR &=~(0x1f<<26);	
    RCC->CR|=(PLL - 1) << 26;   //PLLֵ 2~16
    
    FLASH->ACR|=FLASH_ACR_LATENCY_1|FLASH_ACR_PRFTBE|FLASH_ACR_PRFTBS;	  //FLASH 2ʱ
    
    RCC->CR|=RCC_CR_PLLON;  //PLLON
    while(!(RCC->CR&RCC_CR_PLLRDY));//ȴPLL
    RCC->CFGR|=RCC_CFGR_SW_PLL;//PLLΪϵͳʱ	 
    while(temp!=0x02)     //ȴPLLΪϵͳʱóɹ
    {    
        temp=RCC->CFGR>>2;
        temp&=0x03;
    }    
}	





void MY_NVIC_PriorityGroupConfig(u8 NVIC_Group)	 
{ 
    u32 temp,temp1;	  
    temp1=(~NVIC_Group)&0x07;//ȡλ
    temp1<<=8;
    temp=SCB->AIRCR;  //ȡǰ
    temp&=0X0000F8FF; //ǰ
    temp|=0X05FA0000; //дԿ
    temp|=temp1;	   
    SCB->AIRCR=temp;  //÷	    	  				   
}
//NVIC 
//NVIC_PreemptionPriority:ռȼ
//NVIC_SubPriority       :Ӧȼ
//NVIC_Channel           :жϱ
//NVIC_Group             :жϷ 0~4
//עȼܳ趨ķΧ!벻Ĵ
//黮:
//0:0λռȼ,4λӦȼ
//1:1λռȼ,3λӦȼ
//2:2λռȼ,2λӦȼ
//3:3λռȼ,1λӦȼ
//4:4λռȼ,0λӦȼ
//NVIC_SubPriorityNVIC_PreemptionPriorityԭ,ֵԽС,Խ	   
void MY_NVIC_Init(u8 NVIC_PreemptionPriority,u8 NVIC_SubPriority,u8 NVIC_Channel,u8 NVIC_Group)	 
{ 
    u32 temp;	
    MY_NVIC_PriorityGroupConfig(NVIC_Group);//÷
    temp=NVIC_PreemptionPriority<<(4-NVIC_Group);	  
    temp|=NVIC_SubPriority&(0x0f>>NVIC_Group);
    temp&=0xf;								//ȡλ  
    NVIC->ISER[NVIC_Channel/32]|=(1<<NVIC_Channel%32);//ʹжλ(ҪĻ,෴OK) 
    NVIC->IP[NVIC_Channel]|=temp<<4;		//Ӧȼȼ   	    	  				   
} 

